/* $Id: attrib.h 23 2007-04-11 00:58:41Z lukasz $ */
/*
 *  FedStage DRMAA for PBS Pro
 *  Copyright (C) 2006-2007  Fedstage Systems Inc.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __DRMAA__PBS_ATTRIB_H
#define __DRMAA__PBS_ATTRIB_H

#ifdef HAVE_CONFIG_H
#	include <config.h>
#endif

#include <sys/types.h>
#include <stdbool.h>
#include <drmaa_utils/attrib.h>

typedef enum {
	/* Additional Torque/OpenPBS attribs (not in DRMAA specification): */
	/* Used by OpenPBS user commands: */
	ATTR_CHECKPOINT = MAX_DRMAA_ATTR+1,
	ATTR_GROUP_LIST,
	ATTR_HOLD_TYPES,
	ATTR_KEEP_FILES,
	ATTR_RESOURCES,
	ATTR_MAIL_POINTS,
	ATTR_PRIORITY,
	ATTR_DESTINATION_QUEUE,
	ATTR_RERUNABLE,
	ATTR_USER_LIST,
	ATTR_ACCOUNT_NAME,
	ATTR_SHELL,
	ATTR_DEPENDENCIES,
	ATTR_INTERACTIVE,
	ATTR_STAGEIN,
	ATTR_STAGEOUT,

	/* Additional job and general attribute names: */
	ATTR_JOB_STATE,
	ATTR_CTIME,
	ATTR_MTIME,
	ATTR_QTIME,
	ATTR_ETIME,
	ATTR_RESOURCES_USED,
	ATTR_EXIT_STATUS,
	ATTR_JOB_OWNER,
	ATTR_EUSER,
	ATTR_EGROUP,
	ATTR_HOP_COUNT,
	ATTR_SECURITY,
	ATTR_SCHEDULER_HINT,
	ATTR_SERVER,
	ATTR_QUEUE,
	ATTR_QUEUE_RANK,
	ATTR_EXECUTION_HOST,
	ATTR_TOTAL_JOBS,
	ATTR_MAX_RUNNING,
	ATTR_COMMENT,
	ATTR_JOB_COOKIE,
	ATTR_HASHNAME,
	ATTR_SESSION_ID,
	ATTR_ALT_ID,

	N_PBS_DRMAA_ATTRIBS
} pbs_attribute_t;

#endif /* __DRMAA__PBS_ATTRIB_H */

