/* $Id: test-datetime.c 529 2007-12-20 21:04:22Z lukasz $ */

#include <drmaa_utils/common.h>
#include <drmaa_utils/datetime.h>
#include <stdio.h>

int
main( int argc, char *argv[] )
{
	drmaa_err_ctx_t errctx, *err=&errctx;
	char line[ 1024 ];

	drmaa_err_create( err, NULL );

	while( OK(err)  &&  fgets( line, sizeof(line), stdin ) )
	 {
		time_t t;
		struct tm local_time;
		t = drmaa_parse_datetime( line, err );
		if( OK(err) )
		 {
			localtime_r( &t, &local_time );
			printf( "%04d%02d%02d%02d%02d.%02d\n",
					local_time.tm_year + 1900,
					local_time.tm_mon + 1,
					local_time.tm_mday,
					local_time.tm_hour,
					local_time.tm_min,
					local_time.tm_sec
					);
		 }
	 }

	if( err->rc )
		fprintf( stderr, "%s (rc=%d)", err->msg, err->rc );
	return err->rc;
}


